Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Attributes | List of all members
Botan::XMSS_WOTS_Addressed_PublicKey Class Reference

`#include <xmss_wots_addressed_publickey.h>`

Inheritance diagram for Botan::XMSS_WOTS_Addressed_PublicKey:

## Public Member Functions
XMSS_Address & | address ()
const XMSS_Address & | address () const
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint_public (const std::string &alg="SHA-256") const
OID | get_oid () const override
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
XMSS_WOTS_PublicKey & | public_key ()
const XMSS_WOTS_PublicKey & | public_key () const
std::vector< uint8_t > | public_key_bits () const override
std::vector< uint8_t > | subject_public_key () const
| XMSS_WOTS_Addressed_PublicKey (const XMSS_WOTS_PublicKey &public_key)
| XMSS_WOTS_Addressed_PublicKey (const XMSS_WOTS_PublicKey &public_key, const XMSS_Address &adrs)
| XMSS_WOTS_Addressed_PublicKey (XMSS_WOTS_PublicKey &&public_key)
| XMSS_WOTS_Addressed_PublicKey (XMSS_WOTS_PublicKey &&public_key, XMSS_Address &&adrs)

## Protected Attributes
XMSS_Address | m_adrs
XMSS_WOTS_PublicKey | m_pub_key

## Detailed Description

Wrapper class to pair a XMSS_WOTS_PublicKey with an XMSS Address. Since the PK_Ops::Verification interface does not allow an extra address parameter to be passed to the sign(RandomNumberGenerator&), the address needs to be stored together with the key and passed to the XMSS_WOTS_Verification_Operation() on creation.

Definition at line 24 of file xmss_wots_addressed_publickey.h.

## Constructor & Destructor Documentation

## ◆ XMSS_WOTS_Addressed_PublicKey() [1/4]

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | const XMSS_WOTS_PublicKey & | public_key | ) |
| inline

Definition at line 27 of file xmss_wots_addressed_publickey.h.

28 : m_pub_key(public_key), m_adrs() {}
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:90
Botan::XMSS_WOTS_Addressed_PublicKey::public_key
const XMSS_WOTS_PublicKey & public_key() const
Definition: xmss_wots_addressed_publickey.h:41
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:91

## ◆ XMSS_WOTS_Addressed_PublicKey() [2/4]

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | const XMSS_WOTS_PublicKey & | public_key,
|  | const XMSS_Address & | adrs
| ) |  |
| inline

Definition at line 30 of file xmss_wots_addressed_publickey.h.

32 : m_pub_key(public_key), m_adrs(adrs) {}

## ◆ XMSS_WOTS_Addressed_PublicKey() [3/4]

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | XMSS_WOTS_PublicKey && | public_key | ) |
| inline

Definition at line 34 of file xmss_wots_addressed_publickey.h.

35 : m_pub_key(std::move(public_key)), m_adrs() {}

## ◆ XMSS_WOTS_Addressed_PublicKey() [4/4]

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | XMSS_WOTS_PublicKey && | public_key,
|  | XMSS_Address && | adrs
| ) |  |
| inline

Definition at line 37 of file xmss_wots_addressed_publickey.h.

39 : m_pub_key(std::move(public_key)), m_adrs(std::move(adrs)) {}

## Member Function Documentation

## ◆ address() [1/2]

XMSS_Address & Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) |
| inline

Definition at line 45 of file xmss_wots_addressed_publickey.h.

45{ return m_adrs; }

References m_adrs.

## ◆ address() [2/2]

const XMSS_Address & Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) | const
| inline

Definition at line 44 of file xmss_wots_addressed_publickey.h.

44{ return m_adrs; }

References m_adrs.

## ◆ algo_name()

std::string Botan::XMSS_WOTS_Addressed_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 47 of file xmss_wots_addressed_publickey.h.

48 {
49 return m_pub_key.algo_name();
50 }
Botan::XMSS_WOTS_PublicKey::algo_name
std::string algo_name() const override
Definition: xmss_wots.h:336

References Botan::XMSS_WOTS_PublicKey::algo_name(), and m_pub_key.

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 52 of file xmss_wots_addressed_publickey.h.

53 {
54 return m_pub_key.algorithm_identifier();
55 }
Botan::XMSS_WOTS_PublicKey::algorithm_identifier
AlgorithmIdentifier algorithm_identifier() const override
Definition: xmss_wots.h:341

References Botan::XMSS_WOTS_PublicKey::algorithm_identifier(), and m_pub_key.

## ◆ check_key()

bool Botan::XMSS_WOTS_Addressed_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 57 of file xmss_wots_addressed_publickey.h.

58 {
59 return m_pub_key.check_key(rng, strong);
60 }
Botan::XMSS_WOTS_PublicKey::check_key
bool check_key(RandomNumberGenerator &, bool) const override
Definition: xmss_wots.h:346

References Botan::XMSS_WOTS_PublicKey::check_key(), and m_pub_key.

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| inline override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 63 of file xmss_wots_addressed_publickey.h.

65 {
66 return m_pub_key.create_verification_op(params, provider);
67 }
Botan::Public_Key::create_verification_op
virtual std::unique_ptr< PK_Ops::Verification > create_verification_op(const std::string &params, const std::string &provider) const
Definition: pk_keys.cpp:107

References Botan::Public_Key::create_verification_op(), and m_pub_key.

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength | ( |  | ) | const
| inline override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 74 of file xmss_wots_addressed_publickey.h.

75 {
76 return m_pub_key.estimated_strength();
77 }
Botan::XMSS_WOTS_PublicKey::estimated_strength
size_t estimated_strength() const override
Definition: xmss_wots.h:351

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and m_pub_key.

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_oid()

OID Botan::XMSS_WOTS_Addressed_PublicKey::get_oid | ( |  | ) | const
| inline override virtual

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented from Botan::Public_Key.

Definition at line 69 of file xmss_wots_addressed_publickey.h.

70 {
71 return m_pub_key.get_oid();
72 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and m_pub_key.

## ◆ key_length()

size_t Botan::XMSS_WOTS_Addressed_PublicKey::key_length | ( |  | ) | const
| inline override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 79 of file xmss_wots_addressed_publickey.h.

80 {
81 return m_pub_key.estimated_strength();
82 }

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and m_pub_key.

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ public_key() [1/2]

XMSS_WOTS_PublicKey & Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) |
| inline

Definition at line 42 of file xmss_wots_addressed_publickey.h.

42{ return m_pub_key; }

References m_pub_key.

## ◆ public_key() [2/2]

const XMSS_WOTS_PublicKey & Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) | const
| inline

Definition at line 41 of file xmss_wots_addressed_publickey.h.

41{ return m_pub_key; }

References m_pub_key.

## ◆ public_key_bits()

std::vector< uint8_t > Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits | ( |  | ) | const
| inline override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 84 of file xmss_wots_addressed_publickey.h.

85 {
86 return m_pub_key.public_key_bits();
87 }
Botan::XMSS_WOTS_PublicKey::public_key_bits
std::vector< uint8_t > public_key_bits() const override
Definition: xmss_wots.h:361

References m_pub_key, and Botan::XMSS_WOTS_PublicKey::public_key_bits().

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_adrs

XMSS_Address Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
| protected

Definition at line 91 of file xmss_wots_addressed_publickey.h.

Referenced by address().

## ◆ m_pub_key

XMSS_WOTS_PublicKey Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
| protected

Definition at line 90 of file xmss_wots_addressed_publickey.h.

Referenced by algo_name(), algorithm_identifier(), check_key(), create_verification_op(), estimated_strength(), get_oid(), key_length(), public_key(), and public_key_bits().

The documentation for this class was generated from the following file:

- src/lib/pubkey/xmss/xmss_wots_addressed_publickey.h